//+------------------------------------------------------------------+
//|                                                     seasonal.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property description "Seasonal moves indicator"
#property indicator_separate_window
//--- indicator settings
#property indicator_buffers 4
#property indicator_plots  2
#property indicator_type1   DRAW_LINE
#property indicator_type2   DRAW_LINE

#property indicator_style1  STYLE_SOLID
#property indicator_style2  STYLE_SOLID

#property indicator_width1  2
#property indicator_width2  2

#property indicator_color1  DodgerBlue
#property indicator_color2  Gold
#property indicator_color3  clrNONE
#property indicator_color4  clrNONE
#include <InitMQL4.mqh>
//--- indicator parameters
input int  years=5;  // Number of years for averaging:
//+------------------------------------------------------------------+
//| Types of prices                                                  |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
   if(_Period!=PERIOD_D1)
     {
      IndicatorSetString(INDICATOR_SHORTNAME,"Working timeframe is only daily!");
      work=false;
      return(INIT_SUCCEEDED);
     }
   if(years<=0)
     {
      IndicatorSetString(INDICATOR_SHORTNAME,"Wrong parameter!");
      work=false;
      return(INIT_SUCCEEDED);
     }
//---
   //IndicatorBuffers(2);
   IndicatorSetInteger(INDICATOR_DIGITS,_Digits);
//--- indicator short name
   IndicatorSetString(INDICATOR_SHORTNAME," "+(string)years+" years.    ");
//--- drawing settings


//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
 {
   ArraySetAsSeries(time,true);

//---
   if(rates_total==prev_calculated)
       return(rates_total);
   Function();
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
//| OnChartEvent()                                                   |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,const long &lparam,const double &dparam,const string &sparam)
  {
   if(id!=CHARTEVENT_CLICK)
      return;
   int diff=ChartGetInteger(0,CHART_VISIBLE_BARS,0)-ChartGetInteger(0,CHART_FIRST_VISIBLE_BAR,0);
   if(diff<0 || q==diff || !work)
      return;
   q=diff;
   Function();
  }
//+------------------------------------------------------------------+
//| Function()                                                       |
//+------------------------------------------------------------------+
void Function()
  {
  }